' ------ Controller -------------

$regfile = "m328pdef.dat" 
...

' ------ Konfiguration Pins -----

Ddrb.3 = 1                       ' SDI - MOSI
Ddrb.4 = 0                       ' SDO - MISO
Ddrb.5 = 1                       ' SCLK
Ddrd.2 = 0                       ' EOC/INT/CDI  (OOI)
Ddrd.5 = 1                       ' FS/CS    ADC1
Ddrd.6 = 1                       ' /CONVST
Ddrd.7 = 1                       ' Reset ADC

' ------ Variablen --------------
Dim I As Byte
Dim J As Integer
Dim W As Word , Channel As Byte
Dim Messdata(20) As Byte
Dim Datensatznr As Dword
Dim Ads8332a(3) As Byte          ' Ads8322 Bytes Konfiguration
Dim Ads8332data(20) As Byte      ' Ads8322 Messdaten
Dim Adschannel As Byte           ' ADS KanalNr.
Dim Tempbyte1 As Byte
Dim Tempbyte2 As Byte

' ------ Aliases ----------------

Eoc Alias Portd.2                ' EOC/INT/CDI
Cs1 Alias Portd.5                ' FS CS ADC 
Resetadc Alias Portd.7           ' Reset  ADC
Convst Alias Portd.6             ' CONVST ADC

'--------------------------------
Progstart:

' Ports Startoutput
Portb.3 = 1                      ' SDI (ADC (MOSI Contr.)
Portb.5 = 1                      ' SCLK alle ADC
Portd.5 = 1                      ' FS/CS    ADC1
Portd.6 = 1                      ' /CONVST
Portd.7 = 1                      ' Reset ADC

' Config SPI
Cs1 = 1                          ' CS ADC auf High
Waitms 1
Resetadc = 0
Waitms 100
Resetadc = 1

Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = High , Phase = 0 , Clockrate = 16 , Noss = 0

Spiinit

Gosub Setads8332                 ' ADC konfigurieren

Do

' Hauptschleife
	Gosub Readads8332
Loop

End

'---------------------------------

Readads8332:

Adschannel = 0

For Adschannel = 0 To 7
   Gosub Selectchannel
   Gosub Readadsdata

' ... gelesene Daten verarbeiten

Next Adschannel

Return

'---------------------------------

Readadsdata:

Ads8332a(1) = &B11011111         ' High
Ads8332a(2) = &B11111111         ' Low-Byte

Convst = 0
Waitus 5
Convst = 1
Cs1 = 0

Spiout Ads8332a(1) , 2

Cs1 = 1
Waitus 10
Cs1 = 0

Ads8332a(1) = &B11011111         ' High
Ads8332a(2) = &B11111111         ' Low 1. adc

Ads8332a(1) = Spimove(2)

Cs1 = 1

Return

'---------------------------------

Selectchannel:

Tempbyte1 = Adschannel

Shift Tempbyte1 , Left , 4
Tempbyte1 = &B11111111 And Tempbyte1
Tempbyte1 = Tempbyte1 Or &B00001111

Ads8332a(1) = Tempbyte1          ' Kanalnummer High-Byte
Ads8332a(2) = &B11111111         ' Low-Byte

Cs1 = 0
Waitus 10
Spiout Ads8332a(1) , 2           ' Schreibe 2 Bytes

Cs1 = 1

Return

'---------------------------------
' ADC einstellen
Setads8332:
' 1110 = Schreiben CFR
' 1101 = Daten lesen
' 1100 = Lesen CFR
' 1110 D11 ... D0

Ads8332a(1) = &B11100111
Ads8332a(2) = &B11111101

Cs1 = 0
Waitus 10
Spiout Ads8332a(1) , 2
Cs1 = 1

Return

'---------------------------------